<?php

namespace Drupal\commerce_dibs\PluginForm\OffsiteRedirect;

use Drupal\commerce_payment\PluginForm\PaymentOffsiteForm;
use Drupal\Core\Form\FormStateInterface;

class EasyHostedPaymentPage extends PaymentOffsiteForm {

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);

    /** @var \Drupal\commerce_payment\Entity\PaymentInterface $payment */
    $payment = $this->entity;
    $payment_gateway = $payment->getPaymentGateway();

    /** @var \Drupal\commerce_dibs\EasyOrderBuilder $order_builder */
    $order_builder = \Drupal::service('commerce_dibs.easy_order_builder');
    $dibs_order = $order_builder->buildOrder($payment->getOrder());
    $dibs_order['checkout']['returnUrl'] = $form['#return_url'];
    $dibs_order['checkout']['integrationType'] = 'HostedPaymentPage';

    /** @var \Drupal\commerce_dibs\EasyApiHelper $apiHelper */
    $apiHelper = \Drupal::service('commerce_dibs.easy_api_helper');
    $apiHelper->setEnvironment($payment_gateway->getPluginConfiguration()['mode']);
    $apiHelper->setSecretKey($payment_gateway->getPluginConfiguration()['secret_key']);

    try {
      $result = $apiHelper->createPayment($dibs_order);
    }
    catch (\Exception $exception) {
      return $this->buildRedirectForm($form, $form_state, $form['#cancel_url'], []);
    }
    return $this->buildRedirectForm($form, $form_state, $result['hostedPaymentPageUrl'], []);
  }

}
